#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPolygonMode(GL_FRONT, GL_FILL);
	glPolygonMode(GL_BACK, GL_LINE);
	glLoadIdentity();
	gluLookAt(
		0.0,  0.0,  6.0,
		0.0,  0.0,  0.0,
		0.0,  1.0,  0.0);

	glBegin(GL_TRIANGLES);
		// triangle 1
		glColor4f(1.0, 0.0, 0.0, 1.0);	glVertex3f(-2.0, -1.0,  0.5);
		glColor4f(0.0, 1.0, 0.0, 1.0);	glVertex3f( 2.0, -1.5, -0.5);
		glColor4f(0.0, 0.0, 1.0, 1.0);	glVertex3f( 2.0, -0.5, -0.5);
		// triangle 2
		glColor4f(1.0, 0.0, 0.0, 1.0);	glVertex3f( 1.0, -2.0,  0.5);
		glColor4f(0.0, 1.0, 0.0, 1.0);	glVertex3f( 1.5,  2.0, -0.5);
		glColor4f(0.0, 0.0, 1.0, 1.0);	glVertex3f( 0.5,  2.0, -0.5);
		// triangle 3
		glColor4f(1.0, 0.0, 0.0, 1.0);	glVertex3f( 2.0,  1.0,  0.5);
		glColor4f(0.0, 1.0, 0.0, 1.0);	glVertex3f(-2.0,  1.5, -0.5);
		glColor4f(0.0, 0.0, 1.0, 1.0);	glVertex3f(-2.0,  0.5, -0.5);
		// triangle 4
		glColor4f(1.0, 0.0, 0.0, 1.0);	glVertex3f(-1.0,  2.0,  0.5);
		glColor4f(0.0, 1.0, 0.0, 1.0);	glVertex3f(-1.5, -2.0, -0.5);
		glColor4f(0.0, 0.0, 1.0, 1.0);	glVertex3f(-0.5, -2.0, -0.5);
	glEnd();	

	glFlush();
	glutSwapBuffers();
}

void reshape(int w, int h)
{
	// define viewport
	glViewport(0, 0, w, h);

	// configuration of projection matrix
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, (GLfloat)w / (GLfloat)h, 1.0, 100.0);

	// configuration of model view matrix
	glMatrixMode(GL_MODELVIEW);
}

int main(int argc, char ** argv)
{
	// general initialisation
	glutInit(&argc, argv);
	glutInitWindowSize(300, 300);
	glutInitWindowPosition(0, 0);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_ALPHA);
	glutCreateWindow("OpenGL Tutorial 02");
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);

	// configuration
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glEnable(GL_DEPTH_TEST);

	// go
	glutMainLoop();
	return 0;
}
